module JavaClass (module JavaClass) where

import qualified Data.Set as Set
import Data.Set (Set)
import Data.Maybe (Maybe)

import JavaClassAccess (JavaClassAccess)
import JavaClassModifier (JavaClassModifier)
import ClassTypeParameter (ClassTypeParameter, ClassType)

data JavaClass = JavaClass { name       :: String
        , accessModifier                :: JavaClassAccess
        , classModifier                 :: Maybe JavaClassModifier
        , isAbstract                    :: Bool
        , typeParameters                :: [ClassTypeParameter]
        , extends                       :: Maybe ClassType
        , implements                    :: [ClassType]
        , permits                       :: [String]
        }
        deriving Show
